breed [people person]
breed [bugs bug]
people-own [age gender immunityTime illnessTime]
bugs-own [age gender]

to setup
  ca
  create-people numPeopleblue [
    setxy random-xcor random-ycor
    set shape "person"
    set color blue
    set size 2.5
  ]
  create-bugs numBugs [
    setxy random-xcor random-ycor
    set shape "bug1"
    set color red
    set size 1.5
  ]

 create-people numPeoplered [
    setxy random-xcor random-ycor
    set shape "person"
    set color red
     set age random maxAge
    set size 2.5
  ]

  ask n-of numHospitals patches [set pcolor white]
  reset-ticks
end

to go
  tick
  moveEveryone
  spreadIllness
  Hospitals
  deathToPeople
  deathToBugs
  createMoreBugs
  healSpontanious
endOfillness

end

to moveEveryone
  ask people [
    rt random 91 - 45 fd 1
  ]
  ask bugs [
    rt random 91 - 45 fd .5
  ]

end

to spreadIllness
  ask people with [color = red]
  [
    ask people in-radius 1 with [color = blue][
      if (random 100 < chanceOfinfection) [
        if (immunityTime = 0) [set color red]
      ]
    ]
  ]
  ask bugs with [color = red]
  [
    ask people in-radius 1 with [color = blue][
      if (random 100 < chanceOfinfection) [
        if (immunityTime = 0) [set color red print "someone is infected"]
      ]
    ]
  ]
  ask people with [color = red]
  [
    ask bugs in-radius 1 with [color = blue][
      set color red
    ]
  ]
  ask bugs with [color = red]
  [
    ask bugs in-radius 1 with [color = blue][
      set color red
    ]
  ]
end

to Hospitals
  ask people with [color = red and pcolor = white]
  [set color blue
    set immunityTime immunityDuration
    set illnessTime 0
  ]
end

to deathToPeople
  ask people with [color = red][
   set age age + 1
    if (random maxAge = 0) [die]
  ]

end

to deathToBugs
     ask bugs with [color = red][
   set age age + 1
    if (random bugsMaxage = 0) [die]
  ]
end

to createMoreBugs
  if random 100 < percentageChangeOfBugProduction [
    create-bugs 1[
          setxy random-xcor random-ycor
    set shape "bug1"
    set color red
    set size 1.5
    ]
  ]
end

to healSpontanious
  ask people with [color = red][
    if (random 100 < chanceOfrecovery) [
      set color blue
      set immunityTime immunityDuration
      set illnessTime 0
    ]
  ]
  ask people with [immunityTime > 0][
    set immunityTime (immunityTime - 1)
  ]

end

to endOfillness
  ask people with [color = red][
    set illnessTime (illnessTime + 1)
    if (illnessTime > illnessDuration)
    [
      ifelse (random 100 < percentageMortality)
      [
        die
      ]
      [
            set color blue
      set immunityTime immunityDuration
        set illnessTime 0
      ]
    ]
  ]
end
@#$#@#$#@
GRAPHICS-WINDOW
210
10
647
448
-1
-1
13.0
1
10
1
1
1
0
1
1
1
-16
16
-16
16
0
0
1
ticks
30.0

BUTTON
91
139
157
172
NIL
setup\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
97
190
152
223
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
20
332
192
365
numHospitals
numHospitals
0
10
3.0
1
1
NIL
HORIZONTAL

BUTTON
91
89
154
122
NIL
ca
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
20
237
192
270
numPeopleblue
numPeopleblue
0
100
100.0
1
1
NIL
HORIZONTAL

SLIDER
20
300
192
333
numBugs
numBugs
0
100
20.0
1
1
NIL
HORIZONTAL

SLIDER
20
267
192
300
numpeoplered
numpeoplered
0
100
10.0
1
1
NIL
HORIZONTAL

SLIDER
20
364
192
397
chanceOfinfection
chanceOfinfection
0
100
99.0
1
1
NIL
HORIZONTAL

PLOT
721
135
921
285
Virus Spreading Graph
Time
infectedpeople
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default " 1.0 0 -16777216 true "" "plot count people with [color = red]"

SLIDER
20
397
192
430
maxAge
maxAge
0
100
50.0
1
1
NIL
HORIZONTAL

SLIDER
20
429
192
462
chanceOfrecovery
chanceOfrecovery
0
100
20.0
1
1
NIL
HORIZONTAL

SLIDER
19
462
191
495
immunityDuration
immunityDuration
0
365
365.0
1
1
NIL
HORIZONTAL

SLIDER
132
545
304
578
illnessDuration
illnessDuration
0
100
10.0
1
1
NIL
HORIZONTAL

SLIDER
390
509
578
542
percentageMortality
percentageMortality
0
20
20.0
1
1
%
HORIZONTAL

SLIDER
212
470
384
503
bugsMaxage
bugsMaxage
0
56
5.0
1
1
NIL
HORIZONTAL

SLIDER
362
556
649
589
percentageChangeOfBugProduction
percentageChangeOfBugProduction
0
100
50.0
1
1
%
HORIZONTAL

@#$#@#$#@
## WHAT IS IT?

This is a model that resembles and simulates the outcome of the dengue virus. 
This netlogo virus project could potentially be used by public health policy experts to notice the effects of the disease. 
Several variables are available to the user, this can enable them to change the conditions of the model and see what the outcome of these alterations may be. 

## HOW IT WORKS

There are a range of variables that can be changed in this model. These may vary as the effect of the disease can be changed, the environment and care that is provided to the people in the simulation can also be altered. 
There are sliders that are placed on the left hand side of the diagram, these allow the user to change the set of variables and make a number of predictions. 

## HOW TO USE IT

The sliders are classified, these are variables that can be changed and used to adhere the outcome of the simulation. Each slider is given a title and can be identified by their names. The graph on the right hand side of the model will determine how many people are infected by the dengue disease. The results on this graph will constantly change throughout the simulation as several patients will recover from the disease.

## THINGS TO NOTICE

Some of the key elements in this diagram are the variables. The percentage change and the risk at which the people are, are interesting factors that I would recommend noticing. The immunity of the people who have already had the disease is also something that I would like to put into consideration as the infection of the disease is restrained (limited through the procedures that were made in the "code"). Setting limitations in a simulated model can become challenging but it is also vital as it may dramatically change the result of each simulation. 

## THINGS TO TRY

Experimenting with the model can be fun as there are several variables that are at the disposal of the user. Changing the quantity of people that are spawned in the simulation can change the results of the model as the number of infected people/"turtles" is either increased or decreased. Increasing the reproduction of bugs can adhere the outcome of the model as there could be a "bug" apocalypse. 

## EXTENDING THE MODEL

Changing the numeration of the variables could make the model more realistic. Using accurate values and alternating the percentage of "risk" at which the people are could complicate the model but also make it match a realistic situation in which the disease (virus) is spreading. 

## NETLOGO FEATURES"

Some of the interesting features that I used in this model includes the use of problem decomposition. This is a technique used to break down procedures, to make these either easier to conceive or comprehend. Placing each procedure and classifying them in subcategories clarifies the code for the user and the programer. Forming my own variables facilitated my work and the understanding of the user as each factor was arranged and named from their function.  

## RELATED MODELS

The model named Disease Solo in the NetLogo Models Library resembles the simulation that I have created as we observe the contamination and outspread of a disease. The agent sets are different in each model although the concept and the spreading of the disease amongst people (multiple breeds) is similar. 

## CREDITS AND REFERENCES

https://www.webmd.com/a-to-z-guides/dengue-fever-reference#1
https://www.mayoclinic.org/diseases-conditions/dengue-fever/symptoms-causes/syc-20353078
https://www.ncbi.nlm.nih.gov/pmc/articles/PMC3381442/
https://www.who.int/news-room/fact-sheets/detail/dengue-and-severe-dengue
https://www.who.int/denguecontrol/faq/en/index2.html
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

bug1
true
0
Polygon -7500403 true true 135 91 120 167 121 168 121 168 137 196 135 212 150 220 166 211 165 196 180 166 165 91 165 91
Polygon -7500403 true true 149 187 128 198 120 241 134 271 149 258 166 271 180 241 171 196 149 187
Polygon -7500403 true true 236 45 214 93 164 108 166 113 220 98 222 91
Polygon -7500403 true true 228 267 198 194 163 162 161 166 194 198
Polygon -7500403 true true 278 206 211 147 168 147 168 150 210 153
Circle -7500403 true true 135 76 30
Rectangle -7500403 true true 143 19 147 79
Rectangle -7500403 true true 151 19 155 81
Line -7500403 true 148 19 149 79
Polygon -7500403 true true 61 47 83 95 133 110 131 115 77 100 75 93
Polygon -7500403 true true 25 208 92 149 135 149 135 152 93 155
Polygon -7500403 true true 228 267 198 194 163 162 161 166 194 198
Polygon -7500403 true true 74 269 97 199 132 167 134 171 101 203
Polygon -7500403 true true 129 185 115 218 109 249 112 280 132 285 139 278 147 260 151 239 154 266 168 284 180 285 195 278 199 255 188 226 180 204 168 189 141 182 141 182
Line -7500403 true 138 84 95 57
Line -7500403 true 161 84 212 59

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
